package com.work.provide_origin.origin

import android.app.Activity
import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.fragment.app.Fragment
import com.work.provide_origin.R
import com.work.provide_origin.databinding.ActivityGeneralBinding

abstract class GeneralVMFragment<VM : GeneralViewModel> : Fragment(){
    lateinit var activity: Activity
    protected var titleFlag: Boolean = true
    lateinit var activityGeneralBinding: ActivityGeneralBinding
    protected abstract var layout:Int

    override fun onAttach(context: Context) {
        super.onAttach(context)
        activity = context as Activity
    }

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        var view = initDataBinding()
        initDo()
        createLooker()
        initTitle(activityGeneralBinding.includeGeneralTitle)
        initUi()
        initData()
        initEvent()
        return view
    }

    protected open fun initDo(){
    }

    protected open fun initTitle(titleView:View){
        if(titleFlag){
            titleView.visibility = View.VISIBLE
            titleView.findViewById<View>(R.id.free_iv).run {
                setOnClickListener {
                    activity.finish()
                }
            }
            titleView.findViewById<View>(R.id.finish).visibility = View.GONE
        }else {
            titleView.visibility = View.GONE
        }
    }

    protected fun getLeftView():View{
        return activityGeneralBinding.includeGeneralTitle.findViewById(R.id.free_iv)
    }

    protected fun getTitleView():TextView{
        return activityGeneralBinding.includeGeneralTitle.findViewById(R.id.title)
    }

    protected fun setTitleNa(value:String){
        activityGeneralBinding.includeGeneralTitle.findViewById<TextView>(R.id.title).run {
            text = value
        }
    }

    protected fun getRightTv(): TextView {
        return activityGeneralBinding.includeGeneralTitle.findViewById<TextView>(R.id.finish)
    }

    abstract fun initDataBinding():View
    abstract fun createLooker()
    abstract fun initUi()
    abstract fun initData()
    abstract fun initEvent()
}