package com.juling.ipage.ui

import android.util.Log
import android.widget.Toast
import androidx.fragment.app.Fragment
import com.hjq.toast.ToastUtils
import com.juling.ipage.R
import com.juling.ipage.databinding.ActivityNavigationBinding
import com.juling.ipage.navigation.NavigationWidgetClick
import com.work.provide_origin.origin.GeneralAgentActivity
import com.work.provide_tool.util.ToastUtil
import com.work.provide_tool.util.turnPageFrag

abstract class NavigationActivity<T:Fragment> : GeneralAgentActivity<NavigationViewModel,ActivityNavigationBinding>(){
    override var layout: Int
        get() = R.layout.activity_navigation
        set(value) {}

    protected lateinit var fragArray :List<T>

    override fun createLooker() {
    }

    override fun initUi() {
        fragArray = providerFragment()
        initNavigationView()
        initOtherUi()
    }

    private fun initNavigationView(){
        iDataBinding.navigationLl.run {
            navigationWidgetClick = object:NavigationWidgetClick{
                override fun onClick(f: Int, to: Int) {
                    turnPageFrag(R.id.fl, if (f == -1) null else fragArray[f], fragArray[to])
                }
            }
        }
    }

    protected fun setPos(f:Int,to:Int){
        iDataBinding.navigationLl.setPos(f,to)
    }

    abstract fun providerFragment():List<T>
    abstract fun initOtherUi()
}