package com.juling.work_onepage.paging

import androidx.paging.Pager
import androidx.paging.PagingConfig
import androidx.paging.PagingSource
import com.work.provide_tool.apppri.dataro.TalkDb

object InterflowRepository {
    private val pageSz= 5

    private var pagingConfig = PagingConfig(
        pageSize = pageSz,// 每页显示的数据的大小
        prefetchDistance = pageSz,// 预刷新的距离，距离最后一个 item 多远时加载数据
        enablePlaceholders = true,//定义如果PagingSource提供了空占位符，则PagingData是否可以显示空占位符。
        initialLoadSize = pageSz + pageSz + pageSz// 初始化加载数
        ,jumpThreshold = PagingSource.LoadResult.Page.COUNT_UNDEFINED//预取距离，定义访问必须离已加载内容的边缘多远才能触发进一步加载。
    )

    fun getInterflowList() = Pager(pagingConfig){
        TalkDb.get().getInterflowDao().queryInterflowData()
    }.flow
}