package com.juling.work_onepage.ui

import android.os.Bundle
import android.view.View
import androidx.lifecycle.ViewModelProvider
import androidx.recyclerview.widget.DividerItemDecoration
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.SimpleItemAnimator
import com.juling.work_onepage.R
import com.juling.work_onepage.adapter.FriendAdapter
import com.juling.work_onepage.databinding.FragmentTalkBinding
import com.juling.work_onepage.work.FriendViewModel
import com.work.provide_origin.origin.GeneralAgentFragment
import com.work.provide_tool.apppri.dataro.TalkDb
import com.work.provide_tool.apppri.dataro.entity.FriendEntity
import com.work.provide_tool.util.ToastUtil
import com.work.provide_tool.util.keepDataUpdateWithUi

class FriendFragment : GeneralAgentFragment<FriendViewModel, FragmentTalkBinding>() {
    private lateinit var adapter: FriendAdapter
    private val iViewModel by lazy {
        ViewModelProvider(this)[FriendViewModel::class.java]
    }

    override var layout: Int
        get() = R.layout.fragment_talk
        set(value) {}

    override fun createLooker() {
        iViewModel.getFriendList().observe(this) { dt ->
            keepDataUpdateWithUi(this,{
                adapter.submitData(dt)
            })
        }
    }

    override fun initTitle(titleView: View) {
        titleFlag = true
        super.initTitle(titleView)
        getLeftView().visibility = View.GONE
        setTitleNa("消息")

        getTitleView().setOnClickListener {
            keepDataUpdateWithUi(this,{
                TalkDb.get().getFriendDao().insertFriendData(FriendEntity(1,"hello"))
            })
        }
    }

    override fun initUi() {
        initRv()
    }

    private fun initRv(){
        iDataBinding.rv.run {
            adapter = FriendAdapter(activity).apply {
                this@FriendFragment.adapter = this
            }
            layoutManager = LinearLayoutManager(activity)
            addItemDecoration(DividerItemDecoration(activity,DividerItemDecoration.VERTICAL).apply {

            })

            (itemAnimator as SimpleItemAnimator).supportsChangeAnimations = false
        }
    }

    override fun initData() {
    }

    override fun initEvent() {
        adapter.onClick = {view,t,p->
            InterflowActivity.start(t)
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

    }
}